program Project1;

uses
  windows, Graphics, messages, sysutils, DirectDraw;

{$R *.RES}

var
 Instance: HWnd;
 WindowClass: TWndClass;
 Handle: HWnd;
 msg: TMsg;
 FDirectDraw : IDirectDraw7;
 FPrimarySurface : IDirectDrawSurface7;
 hRet : HRESULT;
 SurfaceDesc : TDDSurfaceDesc2;
 DC : HDC;
 bltfx : TDDBLTFX;


procedure DoExit;
begin
 FPrimarySurface := nil;
 FDirectDraw := nil;
 Halt;
end;

function WindowProc (Hwn,msg,wpr,lpr: longint): longint; stdcall;
begin
 result:=defwindowproc(hwn,msg,wpr,lpr);
 if msg=wm_destroy then
  DoExit;

 if msg=wm_KeyDown then
  if wpr=VK_ESCAPE then
   DoExit;

 if msg=WM_PAINT then
  begin
   ZeroMemory(@bltfx, SizeOf(bltfx));
   bltfx.dwSize := sizeof(bltfx);
   bltfx.dwFillColor := 0;
   while True do
    begin
     hRet := FPrimarySurface.Blt(nil, nil, nil, DDBLT_COLORFILL or DDBLT_WAIT, @bltfx);
     if hRet = DDERR_SURFACELOST then
      begin
       hRet := FPrimarySurface._Restore;
       if hRet <> DD_OK then Break;
      end
     else Break;
    end;

  hRet := FPrimarySurface.GetDC(DC);
  if hRet=0 then
   begin
    Rectangle(DC, 100, 100, 440, 280);
    FPrimarySurface.ReleaseDC (DC);
   end;
  end;
end;

begin
 instance :=GetModuleHandle(nil);
 with WindowClass do
  begin
   style:=CS_HRedraw or CS_VRedraw;
   Lpfnwndproc:=@windowproc;
   Hinstance:=Instance;
   HbrBackground:= color_btnface;
   LpszClassName:='DX';
   Hcursor:=LoadCursor(0,IDC_ARROW);
  end;
 RegisterClass (WindowClass);

 Handle:=CreateWindowEx (0,'DX','',WS_POPUP, 5,5, GetSystemMetrics (SM_CXSCREEN), GetSystemMetrics (SM_CYSCREEN),0,0,instance, nil);
 UpdateWindow (Handle);

 hRet := DirectDrawCreateEx (nil, FDirectDraw, IDirectDraw7, nil);
 if hRet <> DD_OK then Halt;

 FDirectDraw.SetCooperativeLevel(Handle, DDSCL_FULLSCREEN or DDSCL_EXCLUSIVE);
 FDirectDraw.SetDisplayMode (640, 480, 16, 0, 0);

 FillChar (SurfaceDesc, SizeOf(SurfaceDesc), 0);
 SurfaceDesc.dwSize := SizeOf(SurfaceDesc);
 SurfaceDesc.dwFlags := DDSD_CAPS;
 SurfaceDesc.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE;
 FDirectDraw.CreateSurface(SurfaceDesc, FPrimarySurface, nil);

 while (GetMessage(msg, 0, 0, 0)) do
  begin
   translatemessage(msg);
   dispatchmessage (msg);
  end;
end.
